diff --git a/src/bin/pg_ctl/pg_ctl.c b/src/bin/pg_ctl/pg_ctl.c
index 3c03ace7ed..018dfe094b 100644
--- a/src/bin/pg_ctl/pg_ctl.c
+++ b/src/bin/pg_ctl/pg_ctl.c
@@ -795,14 +795,14 @@ trap_sigint_during_startup(int sig)
 }
 
 static char *
-find_other_exec_or_die(const char *argv0, const char *target, const char *versionstr)
+find_other_cmd_or_die(const char *argv0, const char *target, const char *versionstr)
 {
 	int			ret;
 	char	   *found_path;
 
 	found_path = pg_malloc(MAXPGPATH);
 
-	if ((ret = find_other_exec(argv0, target, versionstr, found_path)) < 0)
+	if ((ret = find_other_cmd(argv0, target, versionstr, found_path)) < 0)
 	{
 		char		full_path[MAXPGPATH];
 
@@ -831,7 +831,7 @@ do_init(void)
 	char		cmd[MAXPGPATH];
 
 	if (exec_path == NULL)
-		exec_path = find_other_exec_or_die(argv0, "initdb", "initdb (PostgreSQL) " PG_VERSION "\n");
+		exec_path = find_other_cmd_or_die(argv0, "initdb", "initdb (PostgreSQL) " PG_VERSION "\n");
 
 	if (pgdata_opt == NULL)
 		pgdata_opt = "";
@@ -875,7 +875,7 @@ do_start(void)
 		pgdata_opt = "";
 
 	if (exec_path == NULL)
-		exec_path = find_other_exec_or_die(argv0, "postgres", PG_BACKEND_VERSIONSTR);
+		exec_path = find_other_cmd_or_die(argv0, "postgres", PG_BACKEND_VERSIONSTR);
 
 #if defined(HAVE_GETRLIMIT) && defined(RLIMIT_CORE)
 	if (allow_core_files)
@@ -1443,7 +1443,7 @@ pgwin32_CommandLine(bool registration)
 	}
 	else
 	{
-		ret = find_other_exec(argv0, "postgres", PG_BACKEND_VERSIONSTR,
+		ret = find_other_cmd(argv0, "postgres", PG_BACKEND_VERSIONSTR,
 							  cmdPath);
 		if (ret != 0)
 		{
@@ -2208,7 +2208,7 @@ adjust_data_dir(void)
 
 	/* we use a private my_exec_path to avoid interfering with later uses */
 	if (exec_path == NULL)
-		my_exec_path = find_other_exec_or_die(argv0, "postgres", PG_BACKEND_VERSIONSTR);
+		my_exec_path = find_other_cmd_or_die(argv0, "postgres", PG_BACKEND_VERSIONSTR);
 	else
 		my_exec_path = pg_strdup(exec_path);
 
diff --git a/src/bin/pg_ctl/t/001_start_stop.pl b/src/bin/pg_ctl/t/001_start_stop.pl
index b1e419f02e..964e8f046e 100644
--- a/src/bin/pg_ctl/t/001_start_stop.pl
+++ b/src/bin/pg_ctl/t/001_start_stop.pl
@@ -15,10 +15,10 @@ program_help_ok('pg_ctl');
 program_version_ok('pg_ctl');
 program_options_handling_ok('pg_ctl');
 
-command_exit_is([ 'pg_ctl', 'start', '-D', "$tempdir/nonexistent" ],
+command_exit_is([ 'pg', 'ctl', 'start', '-D', "$tempdir/nonexistent" ],
 	1, 'pg_ctl start with nonexistent directory');
 
-command_ok([ 'pg_ctl', 'initdb', '-D', "$tempdir/data", '-o', '-N' ],
+command_ok([ 'pg', 'ctl', 'initdb', '-D', "$tempdir/data", '-o', '-N' ],
 	'pg_ctl initdb');
 command_ok([ $ENV{PG_REGRESS}, '--config-auth', "$tempdir/data" ],
 	'configure authentication');
@@ -40,7 +40,7 @@ else
 }
 close $conf;
 my $ctlcmd = [
-	'pg_ctl', 'start', '-D', "$tempdir/data", '-l',
+	'pg', 'ctl', 'start', '-D', "$tempdir/data", '-l',
 	"$TestLib::log_path/001_start_stop_server.log"
 ];
 if ($Config{osname} ne 'msys')
@@ -59,17 +59,17 @@ else
 # postmaster they start.  Waiting more than the 2 seconds slop time allowed
 # by wait_for_postmaster() prevents that mistake.
 sleep 3 if ($windows_os);
-command_fails([ 'pg_ctl', 'start', '-D', "$tempdir/data" ],
+command_fails([ 'pg', 'ctl', 'start', '-D', "$tempdir/data" ],
 	'second pg_ctl start fails');
-command_ok([ 'pg_ctl', 'stop', '-D', "$tempdir/data" ], 'pg_ctl stop');
-command_fails([ 'pg_ctl', 'stop', '-D', "$tempdir/data" ],
+command_ok([ 'pg', 'ctl', 'stop', '-D', "$tempdir/data" ], 'pg_ctl stop');
+command_fails([ 'pg', 'ctl', 'stop', '-D', "$tempdir/data" ],
 	'second pg_ctl stop fails');
 
 # Log file for default permission test.  The permissions won't be checked on
 # Windows but we still want to do the restart test.
 my $logFileName = "$tempdir/data/perm-test-600.log";
 
-command_ok([ 'pg_ctl', 'restart', '-D', "$tempdir/data", '-l', $logFileName ],
+command_ok([ 'pg', 'ctl', 'restart', '-D', "$tempdir/data", '-l', $logFileName ],
 	'pg_ctl restart with server not running');
 
 # Permissions on log file should be default
@@ -89,21 +89,21 @@ SKIP:
 {
 	skip "group access not supported on Windows", 3 if ($windows_os);
 
-	system_or_bail 'pg_ctl', 'stop', '-D', "$tempdir/data";
+	system_or_bail 'pg', 'ctl', 'stop', '-D', "$tempdir/data";
 
 	# Change the data dir mode so log file will be created with group read
 	# privileges on the next start
 	chmod_recursive("$tempdir/data", 0750, 0640);
 
 	command_ok(
-		[ 'pg_ctl', 'start', '-D', "$tempdir/data", '-l', $logFileName ],
+		[ 'pg', 'ctl', 'start', '-D', "$tempdir/data", '-l', $logFileName ],
 		'start server to check group permissions');
 
 	ok(-f $logFileName);
 	ok(check_mode_recursive("$tempdir/data", 0750, 0640));
 }
 
-command_ok([ 'pg_ctl', 'restart', '-D', "$tempdir/data" ],
+command_ok([ 'pg', 'ctl', 'restart', '-D', "$tempdir/data" ],
 	'pg_ctl restart with server running');
 
-system_or_bail 'pg_ctl', 'stop', '-D', "$tempdir/data";
+system_or_bail 'pg', 'ctl', 'stop', '-D', "$tempdir/data";
diff --git a/src/bin/pg_ctl/t/002_status.pl b/src/bin/pg_ctl/t/002_status.pl
index 606d10560f..4f8f72e8bc 100644
--- a/src/bin/pg_ctl/t/002_status.pl
+++ b/src/bin/pg_ctl/t/002_status.pl
@@ -8,18 +8,18 @@ use Test::More tests => 3;
 my $tempdir       = TestLib::tempdir;
 my $tempdir_short = TestLib::tempdir_short;
 
-command_exit_is([ 'pg_ctl', 'status', '-D', "$tempdir/nonexistent" ],
+command_exit_is([ 'pg', 'ctl', 'status', '-D', "$tempdir/nonexistent" ],
 	4, 'pg_ctl status with nonexistent directory');
 
 my $node = get_new_node('main');
 $node->init;
 
-command_exit_is([ 'pg_ctl', 'status', '-D', $node->data_dir ],
+command_exit_is([ 'pg', 'ctl', 'status', '-D', $node->data_dir ],
 	3, 'pg_ctl status with server not running');
 
-system_or_bail 'pg_ctl', '-l', "$tempdir/logfile", '-D',
+system_or_bail 'pg', 'ctl', '-l', "$tempdir/logfile", '-D',
   $node->data_dir, '-w', 'start';
-command_exit_is([ 'pg_ctl', 'status', '-D', $node->data_dir ],
+command_exit_is([ 'pg', 'ctl', 'status', '-D', $node->data_dir ],
 	0, 'pg_ctl status with server running');
 
-system_or_bail 'pg_ctl', 'stop', '-D', $node->data_dir;
+system_or_bail 'pg', 'ctl', 'stop', '-D', $node->data_dir;
diff --git a/src/bin/pg_ctl/t/003_promote.pl b/src/bin/pg_ctl/t/003_promote.pl
index ecb294b490..d371c9b4a3 100644
--- a/src/bin/pg_ctl/t/003_promote.pl
+++ b/src/bin/pg_ctl/t/003_promote.pl
@@ -8,7 +8,7 @@ use Test::More tests => 12;
 my $tempdir = TestLib::tempdir;
 
 command_fails_like(
-	[ 'pg_ctl', '-D', "$tempdir/nonexistent", 'promote' ],
+	[ 'pg', 'ctl', '-D', "$tempdir/nonexistent", 'promote' ],
 	qr/directory .* does not exist/,
 	'pg_ctl promote with nonexistent directory');
 
@@ -16,14 +16,14 @@ my $node_primary = get_new_node('primary');
 $node_primary->init(allows_streaming => 1);
 
 command_fails_like(
-	[ 'pg_ctl', '-D', $node_primary->data_dir, 'promote' ],
+	[ 'pg', 'ctl', '-D', $node_primary->data_dir, 'promote' ],
 	qr/PID file .* does not exist/,
 	'pg_ctl promote of not running instance fails');
 
 $node_primary->start;
 
 command_fails_like(
-	[ 'pg_ctl', '-D', $node_primary->data_dir, 'promote' ],
+	[ 'pg', 'ctl', '-D', $node_primary->data_dir, 'promote' ],
 	qr/not in standby mode/,
 	'pg_ctl promote of primary instance fails');
 
@@ -36,7 +36,7 @@ $node_standby->start;
 is($node_standby->safe_psql('postgres', 'SELECT pg_is_in_recovery()'),
 	't', 'standby is in recovery');
 
-command_ok([ 'pg_ctl', '-D', $node_standby->data_dir, '-W', 'promote' ],
+command_ok([ 'pg', 'ctl', '-D', $node_standby->data_dir, '-W', 'promote' ],
 	'pg_ctl -W promote of standby runs');
 
 ok( $node_standby->poll_query_until(
@@ -52,7 +52,7 @@ $node_standby->start;
 is($node_standby->safe_psql('postgres', 'SELECT pg_is_in_recovery()'),
 	't', 'standby is in recovery');
 
-command_ok([ 'pg_ctl', '-D', $node_standby->data_dir, 'promote' ],
+command_ok([ 'pg', 'ctl', '-D', $node_standby->data_dir, 'promote' ],
 	'pg_ctl promote of standby runs');
 
 # no wait here
diff --git a/src/bin/pg_ctl/t/005_redirect.pl b/src/bin/pg_ctl/t/005_redirect.pl
new file mode 100644
index 0000000000..ae92a81d74
--- /dev/null
+++ b/src/bin/pg_ctl/t/005_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'ctl'],
+	qr/pg_ctl: no operation specified/,
+	'pg pg_ctl fails');
+
+command_ok(
+	['pg', 'ctl', '--version'],
+	'pg pg_ctl version ok');
+
+command_ok(
+	['pg', 'ctl', '--help'],
+	'pg pg_ctl help ok');
diff --git a/src/bin/pg_dump/Makefile b/src/bin/pg_dump/Makefile
index 2532d9183a..76f23155fe 100644
--- a/src/bin/pg_dump/Makefile
+++ b/src/bin/pg_dump/Makefile
@@ -44,12 +44,12 @@ pg_dumpall: pg_dumpall.o dumputils.o | submake-libpq submake-libpgport submake-l
 	$(CC) $(CFLAGS) pg_dumpall.o dumputils.o $(WIN32RES) $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_dump$(X) '$(DESTDIR)$(bindir)'/pg_dump$(X)
-	$(INSTALL_PROGRAM) pg_restore$(X) '$(DESTDIR)$(bindir)'/pg_restore$(X)
-	$(INSTALL_PROGRAM) pg_dumpall$(X) '$(DESTDIR)$(bindir)'/pg_dumpall$(X)
+	$(INSTALL_PROGRAM) pg_dump$(X) '$(DESTDIR)$(libexecdir)'/pg_dump$(X)
+	$(INSTALL_PROGRAM) pg_restore$(X) '$(DESTDIR)$(libexecdir)'/pg_restore$(X)
+	$(INSTALL_PROGRAM) pg_dumpall$(X) '$(DESTDIR)$(libexecdir)'/pg_dumpall$(X)
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 check:
 	$(prove_check)
@@ -58,7 +58,7 @@ installcheck:
 	$(prove_installcheck)
 
 uninstall:
-	rm -f $(addprefix '$(DESTDIR)$(bindir)'/, pg_dump$(X) pg_restore$(X) pg_dumpall$(X))
+	rm -f $(addprefix '$(DESTDIR)$(libexecdir)'/, pg_dump$(X) pg_restore$(X) pg_dumpall$(X))
 
 clean distclean maintainer-clean:
 	rm -f pg_dump$(X) pg_restore$(X) pg_dumpall$(X) $(OBJS) pg_dump.o common.o pg_dump_sort.o pg_restore.o pg_dumpall.o
diff --git a/src/bin/pg_dump/pg_dumpall.c b/src/bin/pg_dump/pg_dumpall.c
index 8d54849102..fdfe571d4e 100644
--- a/src/bin/pg_dump/pg_dumpall.c
+++ b/src/bin/pg_dump/pg_dumpall.c
@@ -187,8 +187,8 @@ main(int argc, char *argv[])
 		}
 	}
 
-	if ((ret = find_other_exec(argv[0], "pg_dump", PGDUMP_VERSIONSTR,
-							   pg_dump_bin)) < 0)
+	if ((ret = find_other_cmd(argv[0], "pg_dump", PGDUMP_VERSIONSTR,
+							  pg_dump_bin)) < 0)
 	{
 		char		full_path[MAXPGPATH];
 
diff --git a/src/bin/pg_dump/t/004_redirect.pl b/src/bin/pg_dump/t/004_redirect.pl
new file mode 100644
index 0000000000..f2498cf534
--- /dev/null
+++ b/src/bin/pg_dump/t/004_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'dump'],
+	qr/error: connection to database .* failed/,
+	'pg pg_dump fails');
+
+command_ok(
+	['pg', 'dump', '--version'],
+	'pg pg_dump version ok');
+
+command_ok(
+	['pg', 'dump', '--help'],
+	'pg pg_dump help ok');
diff --git a/src/bin/pg_resetwal/Makefile b/src/bin/pg_resetwal/Makefile
index 464268e978..00fafc6fea 100644
--- a/src/bin/pg_resetwal/Makefile
+++ b/src/bin/pg_resetwal/Makefile
@@ -25,13 +25,13 @@ pg_resetwal: $(OBJS) | submake-libpgport
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_resetwal$(X) '$(DESTDIR)$(bindir)/pg_resetwal$(X)'
+	$(INSTALL_PROGRAM) pg_resetwal$(X) '$(DESTDIR)$(libexecdir)/pg_resetwal$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_resetwal$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_resetwal$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_resetwal$(X) $(OBJS)
diff --git a/src/bin/pg_resetwal/t/003_redirect.pl b/src/bin/pg_resetwal/t/003_redirect.pl
new file mode 100644
index 0000000000..f70467110f
--- /dev/null
+++ b/src/bin/pg_resetwal/t/003_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'resetwal'],
+	qr/error: no data directory specified/,
+	'pg pg_resetwal fails');
+
+command_ok(
+	['pg', 'resetwal', '--version'],
+	'pg pg_resetwal version ok');
+
+command_ok(
+	['pg', 'resetwal', '--help'],
+	'pg pg_resetwal help ok');
diff --git a/src/bin/pg_rewind/Makefile b/src/bin/pg_rewind/Makefile
index f398c3d848..dd59c284eb 100644
--- a/src/bin/pg_rewind/Makefile
+++ b/src/bin/pg_rewind/Makefile
@@ -42,13 +42,13 @@ xlogreader.c: % : $(top_srcdir)/src/backend/access/transam/%
 	rm -f $@ && $(LN_S) $< .
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_rewind$(X) '$(DESTDIR)$(bindir)/pg_rewind$(X)'
+	$(INSTALL_PROGRAM) pg_rewind$(X) '$(DESTDIR)$(libexecdir)/pg_rewind$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_rewind$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_rewind$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_rewind$(X) $(OBJS) xlogreader.c
diff --git a/src/bin/pg_rewind/pg_rewind.c b/src/bin/pg_rewind/pg_rewind.c
index 0015d3b461..a8d7b60d10 100644
--- a/src/bin/pg_rewind/pg_rewind.c
+++ b/src/bin/pg_rewind/pg_rewind.c
@@ -835,9 +835,9 @@ getRestoreCommand(const char *argv0)
 		return;
 
 	/* find postgres executable */
-	rc = find_other_exec(argv0, "postgres",
-						 PG_BACKEND_VERSIONSTR,
-						 postgres_exec_path);
+	rc = find_other_cmd(argv0, "postgres",
+						PG_BACKEND_VERSIONSTR,
+						postgres_exec_path);
 
 	if (rc < 0)
 	{
@@ -895,9 +895,9 @@ ensureCleanShutdown(const char *argv0)
 	char		cmd[MAXCMDLEN];
 
 	/* locate postgres binary */
-	if ((ret = find_other_exec(argv0, "postgres",
-							   PG_BACKEND_VERSIONSTR,
-							   exec_path)) < 0)
+	if ((ret = find_other_cmd(argv0, "postgres",
+							  PG_BACKEND_VERSIONSTR,
+							  exec_path)) < 0)
 	{
 		char		full_path[MAXPGPATH];
 
diff --git a/src/bin/pg_rewind/t/007_redirect.pl b/src/bin/pg_rewind/t/007_redirect.pl
new file mode 100644
index 0000000000..9d4be4d081
--- /dev/null
+++ b/src/bin/pg_rewind/t/007_redirect.pl
@@ -0,0 +1,17 @@
+use strict;
+use warnings;
+use TestLib;
+use Test::More tests => 4;
+
+command_fails_like(
+	['pg', 'rewind'],
+	qr/error: no source specified/,
+	'pg pg_rewind fails');
+
+command_ok(
+	['pg', 'rewind', '--version'],
+	'pg pg_rewind version ok');
+
+command_ok(
+	['pg', 'rewind', '--help'],
+	'pg pg_rewind help ok');
diff --git a/src/bin/pg_test_fsync/Makefile b/src/bin/pg_test_fsync/Makefile
index 7632c94eb7..7ef63a172b 100644
--- a/src/bin/pg_test_fsync/Makefile
+++ b/src/bin/pg_test_fsync/Makefile
@@ -17,13 +17,13 @@ pg_test_fsync: $(OBJS) | submake-libpgport
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_test_fsync$(X) '$(DESTDIR)$(bindir)/pg_test_fsync$(X)'
+	$(INSTALL_PROGRAM) pg_test_fsync$(X) '$(DESTDIR)$(libexecdir)/pg_test_fsync$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_test_fsync$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_test_fsync$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_test_fsync$(X) $(OBJS)
diff --git a/src/bin/pg_test_timing/Makefile b/src/bin/pg_test_timing/Makefile
index 334d6ff5c0..bc762113ab 100644
--- a/src/bin/pg_test_timing/Makefile
+++ b/src/bin/pg_test_timing/Makefile
@@ -17,13 +17,13 @@ pg_test_timing: $(OBJS) | submake-libpgport
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_test_timing$(X) '$(DESTDIR)$(bindir)/pg_test_timing$(X)'
+	$(INSTALL_PROGRAM) pg_test_timing$(X) '$(DESTDIR)$(libexecdir)/pg_test_timing$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_test_timing$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_test_timing$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_test_timing$(X) $(OBJS)
diff --git a/src/bin/pg_upgrade/Makefile b/src/bin/pg_upgrade/Makefile
index 0360c37bf9..da9bf0e589 100644
--- a/src/bin/pg_upgrade/Makefile
+++ b/src/bin/pg_upgrade/Makefile
@@ -34,13 +34,13 @@ pg_upgrade: $(OBJS) | submake-libpq submake-libpgport submake-libpgfeutils
 	$(CC) $(CFLAGS) $^ $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)
 
 install: all installdirs
-	$(INSTALL_PROGRAM) pg_upgrade$(X) '$(DESTDIR)$(bindir)/pg_upgrade$(X)'
+	$(INSTALL_PROGRAM) pg_upgrade$(X) '$(DESTDIR)$(libexecdir)/pg_upgrade$(X)'
 
 installdirs:
-	$(MKDIR_P) '$(DESTDIR)$(bindir)'
+	$(MKDIR_P) '$(DESTDIR)$(libexecdir)'
 
 uninstall:
-	rm -f '$(DESTDIR)$(bindir)/pg_upgrade$(X)'
+	rm -f '$(DESTDIR)$(libexecdir)/pg_upgrade$(X)'
 
 clean distclean maintainer-clean:
 	rm -f pg_upgrade$(X) $(OBJS)
@@ -59,7 +59,7 @@ clean distclean maintainer-clean:
 NOTSUBMAKEMAKE=$(MAKE)
 
 check: test.sh all temp-install
-	MAKE=$(NOTSUBMAKEMAKE) $(with_temp_install) bindir=$(abs_top_builddir)/tmp_install/$(bindir) EXTRA_REGRESS_OPTS="$(EXTRA_REGRESS_OPTS)" $(SHELL) $<
+	MAKE=$(NOTSUBMAKEMAKE) $(with_temp_install) bindir=$(abs_top_builddir)/tmp_install/$(bindir) libexecdir=$(abs_top_builddir)/tmp_install/$(libexecdir) EXTRA_REGRESS_OPTS="$(EXTRA_REGRESS_OPTS)" $(SHELL) $<
 
 # installcheck is not supported because there's no meaningful way to test
 # pg_upgrade against a single already-running server
diff --git a/src/bin/pg_upgrade/TESTING b/src/bin/pg_upgrade/TESTING
index e69874b42d..6e01e891d9 100644
--- a/src/bin/pg_upgrade/TESTING
+++ b/src/bin/pg_upgrade/TESTING
@@ -14,7 +14,9 @@ must have done "make install" for both versions.  Then do:
 
 export oldsrc=...somewhere/postgresql	(old version's source tree)
 export oldbindir=...otherversion/bin	(old version's installed bin dir)
+export oldlibexecdir=...otherversion/libexec	(old version's installed libexec dir)
 export bindir=...thisversion/bin	(this version's installed bin dir)
+export libexecdir=...thisversion/libexec	(this version's installed libexec dir)
 export libdir=...thisversion/lib	(this version's installed lib dir)
 sh test.sh
 
diff --git a/src/bin/pg_upgrade/check.c b/src/bin/pg_upgrade/check.c
index 00aef855dc..e025a89dd6 100644
--- a/src/bin/pg_upgrade/check.c
+++ b/src/bin/pg_upgrade/check.c
@@ -503,17 +503,17 @@ create_script_for_cluster_analyze(char **analyze_script_file_name)
 	fprintf(script, "echo %sthis script and run:%s\n",
 			ECHO_QUOTE, ECHO_QUOTE);
 	fprintf(script, "echo %s    \"%s/vacuumdb\" %s--all %s%s\n", ECHO_QUOTE,
-			new_cluster.bindir, user_specification.data,
+			new_cluster.libexecdir, user_specification.data,
 	/* Did we copy the free space files? */
 			(GET_MAJOR_VERSION(old_cluster.major_version) >= 804) ?
 			"--analyze-only" : "--analyze", ECHO_QUOTE);
 	fprintf(script, "echo%s\n\n", ECHO_BLANK);
 
 	fprintf(script, "\"%s/vacuumdb\" %s--all --analyze-in-stages\n",
-			new_cluster.bindir, user_specification.data);
+			new_cluster.libexecdir, user_specification.data);
 	/* Did we copy the free space files? */
 	if (GET_MAJOR_VERSION(old_cluster.major_version) < 804)
-		fprintf(script, "\"%s/vacuumdb\" %s--all\n", new_cluster.bindir,
+		fprintf(script, "\"%s/vacuumdb\" %s--all\n", new_cluster.libexecdir,
 				user_specification.data);
 
 	fprintf(script, "echo%s\n\n", ECHO_BLANK);
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
index 00d71e3a8a..24587c6b8e 100644
--- a/src/bin/pg_upgrade/controldata.c
+++ b/src/bin/pg_upgrade/controldata.c
@@ -119,7 +119,7 @@ get_control_data(ClusterInfo *cluster, bool live_check)
 	{
 		/* only pg_controldata outputs the cluster state */
 		snprintf(cmd, sizeof(cmd), "\"%s/pg_controldata\" \"%s\"",
-				 cluster->bindir, cluster->pgdata);
+				 cluster->libexecdir, cluster->pgdata);
 		fflush(stdout);
 		fflush(stderr);
 
@@ -185,7 +185,7 @@ get_control_data(ClusterInfo *cluster, bool live_check)
 	else
 		resetwal_bin = "pg_resetwal\" -n";
 	snprintf(cmd, sizeof(cmd), "\"%s/%s \"%s\"",
-			 cluster->bindir,
+			 cluster->libexecdir,
 			 live_check ? "pg_controldata\"" : resetwal_bin,
 			 cluster->pgdata);
 	fflush(stdout);
diff --git a/src/bin/pg_upgrade/dump.c b/src/bin/pg_upgrade/dump.c
index 4d730adfe2..22c0b64bc4 100644
--- a/src/bin/pg_upgrade/dump.c
+++ b/src/bin/pg_upgrade/dump.c
@@ -21,9 +21,9 @@ generate_old_dump(void)
 
 	/* run new pg_dumpall binary for globals */
 	exec_prog(UTILITY_LOG_FILE, NULL, true, true,
-			  "\"%s/pg_dumpall\" %s --globals-only --quote-all-identifiers "
+			  "\"%s\" %s --globals-only --quote-all-identifiers "
 			  "--binary-upgrade %s -f %s",
-			  new_cluster.bindir, cluster_conn_opts(&old_cluster),
+			  new_cluster.pg_dumpall_path, cluster_conn_opts(&old_cluster),
 			  log_opts.verbose ? "--verbose" : "",
 			  GLOBALS_DUMP_FILE);
 	check_ok();
@@ -51,9 +51,9 @@ generate_old_dump(void)
 		snprintf(log_file_name, sizeof(log_file_name), DB_DUMP_LOG_FILE_MASK, old_db->db_oid);
 
 		parallel_exec_prog(log_file_name, NULL,
-						   "\"%s/pg_dump\" %s --schema-only --quote-all-identifiers "
+						   "\"%s\" %s --schema-only --quote-all-identifiers "
 						   "--binary-upgrade --format=custom %s --file=\"%s\" %s",
-						   new_cluster.bindir, cluster_conn_opts(&old_cluster),
+						   new_cluster.pg_dump_path, cluster_conn_opts(&old_cluster),
 						   log_opts.verbose ? "--verbose" : "",
 						   sql_file_name, escaped_connstr.data);
 
diff --git a/src/bin/pg_upgrade/exec.c b/src/bin/pg_upgrade/exec.c
index b31cda8fec..aa4e3fda43 100644
--- a/src/bin/pg_upgrade/exec.c
+++ b/src/bin/pg_upgrade/exec.c
@@ -16,7 +16,7 @@
 static void check_data_dir(ClusterInfo *cluster);
 static void check_bin_dir(ClusterInfo *cluster);
 static void get_bin_version(ClusterInfo *cluster);
-static void validate_exec(const char *dir, const char *cmdName);
+static void validate_exec(ClusterInfo *cluster, char **path, const char *cmdName);
 
 #ifdef WIN32
 static int	win32_check_directory_write_permissions(void);
@@ -37,7 +37,7 @@ get_bin_version(ClusterInfo *cluster)
 	int			v1 = 0,
 				v2 = 0;
 
-	snprintf(cmd, sizeof(cmd), "\"%s/pg_ctl\" --version", cluster->bindir);
+	snprintf(cmd, sizeof(cmd), "\"%s/pg_ctl\" --version", cluster->libexecdir);
 
 	if ((output = popen(cmd, "r")) == NULL ||
 		fgets(cmd_output, sizeof(cmd_output), output) == NULL)
@@ -357,10 +357,9 @@ check_data_dir(ClusterInfo *cluster)
 /*
  * check_bin_dir()
  *
- *	This function searches for the executables that we expect to find
- *	in the binaries directory.  If we find that a required executable
- *	is missing (or secured against us), we display an error message and
- *	exit().
+ *	This function searches for the executables that we expect to find in the
+ *	libexec or binaries directory.  If we find that a required executable is
+ *	missing (or secured against us), we display an error message and exit().
  */
 static void
 check_bin_dir(ClusterInfo *cluster)
@@ -375,9 +374,17 @@ check_bin_dir(ClusterInfo *cluster)
 		report_status(PG_FATAL, "\"%s\" is not a directory\n",
 					  cluster->bindir);
 
-	validate_exec(cluster->bindir, "postgres");
-	validate_exec(cluster->bindir, "pg_controldata");
-	validate_exec(cluster->bindir, "pg_ctl");
+	/*
+	 * libexec will not exist on older clusters, but if it exists, it should
+	 * be a directory.
+	 */
+	if (stat(cluster->libexecdir, &statBuf) == 0 && !S_ISDIR(statBuf.st_mode))
+		report_status(PG_FATAL, "\"%s\" is not a directory\n",
+					  cluster->libexecdir);
+
+	validate_exec(cluster, &cluster->postgres_path, "postgres");
+	validate_exec(cluster, &cluster->pg_controldata_path, "pg_controldata");
+	validate_exec(cluster, &cluster->pg_ctl_path, "pg_ctl");
 
 	/*
 	 * Fetch the binary version after checking for the existence of pg_ctl.
@@ -388,9 +395,9 @@ check_bin_dir(ClusterInfo *cluster)
 
 	/* pg_resetxlog has been renamed to pg_resetwal in version 10 */
 	if (GET_MAJOR_VERSION(cluster->bin_version) < 1000)
-		validate_exec(cluster->bindir, "pg_resetxlog");
+		validate_exec(cluster, &cluster->pg_resetwal_path, "pg_resetxlog");
 	else
-		validate_exec(cluster->bindir, "pg_resetwal");
+		validate_exec(cluster, &cluster->pg_resetwal_path, "pg_resetwal");
 
 	if (cluster == &new_cluster)
 	{
@@ -399,63 +406,81 @@ check_bin_dir(ClusterInfo *cluster)
 		 * pg_dumpall are used to dump the old cluster, but must be of the
 		 * target version.
 		 */
-		validate_exec(cluster->bindir, "initdb");
-		validate_exec(cluster->bindir, "pg_dump");
-		validate_exec(cluster->bindir, "pg_dumpall");
-		validate_exec(cluster->bindir, "pg_restore");
-		validate_exec(cluster->bindir, "psql");
-		validate_exec(cluster->bindir, "vacuumdb");
+		validate_exec(cluster, &cluster->initdb_path, "initdb");
+		validate_exec(cluster, &cluster->pg_dump_path, "pg_dump");
+		validate_exec(cluster, &cluster->pg_dumpall_path, "pg_dumpall");
+		validate_exec(cluster, &cluster->pg_restore_path, "pg_restore");
+		validate_exec(cluster, &cluster->psql_path, "psql");
+		validate_exec(cluster, &cluster->vacuumdb_path, "vacuumdb");
 	}
 }
 
-
 /*
  * validate_exec()
  *
- * validate "path" as an executable file
+ * validate "cmdName" as an executable file, either in the cluster's bindir
+ * or libexecdir (if any), and store the valid location for the command in
+ * "path" for future use.
  */
 static void
-validate_exec(const char *dir, const char *cmdName)
+validate_exec(ClusterInfo *cluster, char **path, const char *cmdName)
 {
-	char		path[MAXPGPATH];
+	int			idx;
 	struct stat buf;
+	const char *dir[] = { cluster->bindir, cluster->libexecdir, NULL };
 
-	snprintf(path, sizeof(path), "%s/%s", dir, cmdName);
+	if (cluster->libexecdir == NULL)
+		pg_fatal("libexecdir is null in validate_exec");
+
+	*path = (char *) pg_malloc0(MAXPGPATH);
+	for (idx = 0; dir[idx]; idx++)
+	{
+		snprintf(*path, MAXPGPATH, "%s/%s", dir[idx], cmdName);
 
 #ifdef WIN32
-	/* Windows requires a .exe suffix for stat() */
-	if (strlen(path) <= strlen(EXE_EXT) ||
-		pg_strcasecmp(path + strlen(path) - strlen(EXE_EXT), EXE_EXT) != 0)
-		strlcat(path, EXE_EXT, sizeof(path));
+		/* Windows requires a .exe suffix for stat() */
+		if (strlen(*path) <= strlen(EXE_EXT) ||
+			pg_strcasecmp(*path + strlen(*path) - strlen(EXE_EXT), EXE_EXT) != 0)
+			strlcat(*path, EXE_EXT, sizeof(*path));
 #endif
 
-	/*
-	 * Ensure that the file exists and is a regular file.
-	 */
-	if (stat(path, &buf) < 0)
-		pg_fatal("check for \"%s\" failed: %s\n",
-				 path, strerror(errno));
-	else if (!S_ISREG(buf.st_mode))
-		pg_fatal("check for \"%s\" failed: not a regular file\n",
-				 path);
+		/*
+		 * Ensure that the file exists and is a regular file.
+		 */
+		if (stat(*path, &buf) < 0)
+		{
+			printf("check for %s failed (dir = %s, cmd = %s)", *path, dir[idx], cmdName);
+			continue;
+		}
+		else if (!S_ISREG(buf.st_mode))
+			pg_fatal("check for \"%s\" failed: not a regular file\n",
+					 *path);
 
-	/*
-	 * Ensure that the file is both executable and readable (required for
-	 * dynamic loading).
-	 */
+		/*
+		 * Ensure that the file is both executable and readable (required for
+		 * dynamic loading).
+		 */
 #ifndef WIN32
-	if (access(path, R_OK) != 0)
+		if (access(*path, R_OK) != 0)
 #else
-	if ((buf.st_mode & S_IRUSR) == 0)
+		if ((buf.st_mode & S_IRUSR) == 0)
 #endif
-		pg_fatal("check for \"%s\" failed: cannot read file (permission denied)\n",
-				 path);
+			pg_fatal("check for \"%s\" failed: cannot read file (permission denied)\n",
+					 *path);
 
 #ifndef WIN32
-	if (access(path, X_OK) != 0)
+		if (access(*path, X_OK) != 0)
 #else
-	if ((buf.st_mode & S_IXUSR) == 0)
+		if ((buf.st_mode & S_IXUSR) == 0)
 #endif
-		pg_fatal("check for \"%s\" failed: cannot execute (permission denied)\n",
-				 path);
+			pg_fatal("check for \"%s\" failed: cannot execute (permission denied)\n",
+					 *path);
+
+		/* If we get here, all checks passed */
+		return;
+	}
+
+	/* If we get here, we failed the stat() call, and errno should be set */
+	pg_fatal("check for \"%s\" failed: %s\n",
+			 *path, strerror(errno));
 }
